part of 'home_card.dart';

class _CardLike extends StatelessWidget {
  final String text;
  final String? id;
  final bool isLiked;

  const _CardLike(
    this.text, {
    this.id,
    this.isLiked = false,
  });

  void _onLike(BuildContext context, bool isLiked) {
    if (id != null) {
      context.read<LikeBloc>().add(ChangeLikeEvent(id!));
    }
    ScaffoldMessenger.of(context).showSnackBar(SnackBar(
      content: Text('$text is ${isLiked ? 'liked' : 'disliked'}!',
          style: Theme.of(context).textTheme.bodyLarge),
      backgroundColor: Colors.orangeAccent,
      duration: const Duration(seconds: 1),
    ));
  }

  @override
  Widget build(BuildContext context) {
    return Align(
      alignment: Alignment.bottomRight,
      child: Padding(
        padding: const EdgeInsets.only(
          left: 8,
          right: 16,
          bottom: 16,
        ),
        child: GestureDetector(
          onTap: () => _onLike(context, !isLiked),
          child: AnimatedSwitcher(
            duration: const Duration(milliseconds: 200),
            child: isLiked
                ? const Icon(
                    Icons.favorite,
                    color: Colors.redAccent,
                    key: ValueKey(0),
                  )
                : const Icon(
                    Icons.favorite_border,
                    key: ValueKey(1),
                  ),
          ),
        ),
      ),
    );
  }
}
