part of 'home_page.dart';

class _HomePageList extends StatelessWidget {
  final TextEditingController searchController;
  final ScrollController scrollController;

  const _HomePageList({
    required this.searchController,
    required this.scrollController,
  });

  void _navigateToDetails(BuildContext context, CardData data) {
    Navigator.push(
      context,
      MaterialPageRoute(builder: (context) => DetailsPage(data)),
    );
  }

  Future<void> _onRefresh(BuildContext context) {
    context
        .read<HomeBloc>()
        .add(HomeLoadDataEvent(search: searchController.text));
    return Future.value(null);
  }

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<HomeBloc, HomeState>(
        builder: (context, state) => Visibility(
              visible: state.error == null,
              child: RefreshIndicator(
                onRefresh: () => _onRefresh(context),
                child: ListView.builder(
                    controller: scrollController,
                    padding: const EdgeInsets.only(right: 16, left: 16),
                    itemCount: state.data?.data?.length ?? 0,
                    itemBuilder: (context, index) {
                      final item = state.data?.data?[index];
                      if (item == null) {
                        return const SizedBox.shrink();
                      }
                      return HomeCard.fromData(
                        item,
                        onTap: () => _navigateToDetails(context, item),
                      );
                    }),
              ),
            ));
  }
}
